jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
| 40 | tmp_dir="${TMPDIR}/$USER/${test_dir}" |
| 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | |
| 44 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 45 | export JAVAC="javac -g" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 46 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 47 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 48 | export NEED_DEX="true" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 49 | export USE_JACK="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
| 76 | # If the tree is compiled with Jack, build test with Jack by default. |
| 77 | if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then |
| 78 | USE_JACK="true" |
| 79 | fi |
| 80 | |
| 81 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 82 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 83 | export ANDROID_BUILD_TOP=$oldwd |
| 84 | fi |
| 85 | |
| 86 | # If JACK_VM_COMMAND is not set, assume it launches the prebuilt jack-launcher. |
| 87 | if [ -z "$JACK_VM_COMMAND" ]; then |
| 88 | if [ ! -z "$TMPDIR" ]; then |
| 89 | jack_temp_dir="-Djava.io.tmpdir=$TMPDIR" |
| 90 | fi |
| 91 | export JACK_VM_COMMAND="java -Dfile.encoding=UTF-8 -Xms2560m -XX:+TieredCompilation $jack_temp_dir -jar $ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack-launcher.jar" |
| 92 | fi |
| 93 | |
| 94 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 95 | if [ -z "$JACK_CLASSPATH" ]; then |
| 96 | export JACK_CLASSPATH="$ANDROID_BUILD_TOP/out/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack" |
| 97 | fi |
| 98 | |
| 99 | # If JACK_JAR is not set, assume it is located in the prebuilts directory. |
| 100 | if [ -z "$JACK_JAR" ]; then |
| 101 | export JACK_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack.jar" |
| 102 | fi |
| 103 | |
| 104 | # If JILL_JAR is not set, assume it is located in the prebuilts directory. |
| 105 | if [ -z "$JILL_JAR" ]; then |
| 106 | export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar" |
| 107 | fi |
| 108 | |
| 109 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
| 110 | export JILL="java -jar $JILL_JAR" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 111 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 112 | info="info.txt" |
| 113 | build="build" |
| 114 | run="run" |
| 115 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 116 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 117 | output="output.txt" |
| 118 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 119 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 120 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 121 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 122 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 123 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 124 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 125 | |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 126 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 127 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 128 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 129 | dev_mode="no" |
| 130 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 131 | debug_mode="no" |
| 132 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 133 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 134 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 135 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 136 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 137 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 138 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 139 | basic_verify="false" |
| 140 | gc_verify="false" |
| 141 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 142 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 143 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 144 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 145 | have_dex2oat="yes" |
| 146 | have_patchoat="yes" |
| 147 | have_image="yes" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 148 | image_suffix="" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 149 | pic_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 150 | android_root="/system" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 151 | |
| 152 | while true; do |
| 153 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 154 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 155 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 156 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 157 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 158 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 159 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 160 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 161 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 162 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 163 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 164 | run_args="${run_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 165 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 166 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 167 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 168 | testlib="arttest" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 169 | shift |
| 170 | elif [ "x$1" = "x--dalvik" ]; then |
| 171 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 172 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 173 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 174 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 175 | have_dex2oat="no" |
| 176 | shift |
| 177 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 178 | have_patchoat="no" |
| 179 | shift |
| 180 | elif [ "x$1" = "x--no-image" ]; then |
| 181 | have_image="no" |
| 182 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 183 | elif [ "x$1" = "x--pic-image" ]; then |
| 184 | pic_image_suffix="-pic" |
| 185 | shift |
| 186 | elif [ "x$1" = "x--pic-test" ]; then |
| 187 | run_args="${run_args} --pic-test" |
| 188 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 189 | elif [ "x$1" = "x--relocate" ]; then |
| 190 | relocate="yes" |
| 191 | shift |
| 192 | elif [ "x$1" = "x--no-relocate" ]; then |
| 193 | relocate="no" |
| 194 | shift |
| 195 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 196 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 197 | prebuild_mode="yes" |
| 198 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 199 | elif [ "x$1" = "x--debuggable" ]; then |
| 200 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 201 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 202 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 203 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 204 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 205 | prebuild_mode="no" |
| 206 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 207 | elif [ "x$1" = "x--gcverify" ]; then |
| 208 | basic_verify="true" |
| 209 | gc_verify="true" |
| 210 | shift |
| 211 | elif [ "x$1" = "x--gcstress" ]; then |
| 212 | basic_verify="true" |
| 213 | gc_stress="true" |
| 214 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 215 | elif [ "x$1" = "x--image" ]; then |
| 216 | shift |
| 217 | image="$1" |
| 218 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 219 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 220 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 221 | shift |
| 222 | option="$1" |
| 223 | run_args="${run_args} -Xcompiler-option $option" |
| 224 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 225 | elif [ "x$1" = "x--runtime-option" ]; then |
| 226 | shift |
| 227 | option="$1" |
| 228 | run_args="${run_args} --runtime-option $option" |
| 229 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 230 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 231 | shift |
| 232 | gdb_arg="$1" |
| 233 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 234 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 235 | elif [ "x$1" = "x--debug" ]; then |
| 236 | run_args="${run_args} --debug" |
| 237 | shift |
| 238 | elif [ "x$1" = "x--gdb" ]; then |
| 239 | run_args="${run_args} --gdb" |
| 240 | dev_mode="yes" |
| 241 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 242 | elif [ "x$1" = "x--strace" ]; then |
| 243 | strace="yes" |
| 244 | run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
| 245 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 246 | elif [ "x$1" = "x--zygote" ]; then |
| 247 | run_args="${run_args} --zygote" |
| 248 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 249 | elif [ "x$1" = "x--interpreter" ]; then |
| 250 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 251 | image_suffix="-interpreter" |
| 252 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 253 | elif [ "x$1" = "x--jit" ]; then |
| 254 | run_args="${run_args} --jit" |
Andreas Gampe | 8a159fd | 2015-09-21 15:14:38 -0700 | [diff] [blame^] | 255 | image_suffix="-jit" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 256 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 257 | elif [ "x$1" = "x--optimizing" ]; then |
| 258 | run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing" |
| 259 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 260 | shift |
Nicolas Geoffray | c9338b9 | 2014-12-03 13:36:10 +0000 | [diff] [blame] | 261 | elif [ "x$1" = "x--quick" ]; then |
| 262 | run_args="${run_args} -Xcompiler-option --compiler-backend=Quick" |
| 263 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 264 | elif [ "x$1" = "x--no-verify" ]; then |
| 265 | run_args="${run_args} --no-verify" |
| 266 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 267 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
| 268 | run_args="${run_args} --verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 269 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 270 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 271 | elif [ "x$1" = "x--no-optimize" ]; then |
| 272 | run_args="${run_args} --no-optimize" |
| 273 | shift |
| 274 | elif [ "x$1" = "x--no-precise" ]; then |
| 275 | run_args="${run_args} --no-precise" |
| 276 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 277 | elif [ "x$1" = "x--invoke-with" ]; then |
| 278 | shift |
| 279 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 280 | if [ "x$what" = "x" ]; then |
| 281 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 282 | usage="yes" |
| 283 | break |
| 284 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 285 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 286 | shift |
| 287 | elif [ "x$1" = "x--dev" ]; then |
| 288 | run_args="${run_args} --dev" |
| 289 | dev_mode="yes" |
| 290 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 291 | elif [ "x$1" = "x--build-only" ]; then |
| 292 | build_only="yes" |
| 293 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 294 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 295 | USE_JACK="false" |
| 296 | shift |
| 297 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 298 | USE_JACK="true" |
| 299 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 300 | elif [ "x$1" = "x--output-path" ]; then |
| 301 | shift |
| 302 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 303 | if [ "x$tmp_dir" = "x" ]; then |
| 304 | echo "$0 missing argument to --output-path" 1>&2 |
| 305 | usage="yes" |
| 306 | break |
| 307 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 308 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 309 | elif [ "x$1" = "x--android-root" ]; then |
| 310 | shift |
| 311 | if [ "x$1" = "x" ]; then |
| 312 | echo "$0 missing argument to --android-root" 1>&2 |
| 313 | usage="yes" |
| 314 | break |
| 315 | fi |
| 316 | android_root="$1" |
| 317 | run_args="${run_args} --android-root $1" |
| 318 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 319 | elif [ "x$1" = "x--update" ]; then |
| 320 | update_mode="yes" |
| 321 | shift |
| 322 | elif [ "x$1" = "x--help" ]; then |
| 323 | usage="yes" |
| 324 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 325 | elif [ "x$1" = "x--64" ]; then |
| 326 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 327 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 328 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 329 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 330 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 331 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 332 | elif [ "x$1" = "x--stream" ]; then |
| 333 | trace_stream="true" |
| 334 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 335 | elif [ "x$1" = "x--always-clean" ]; then |
| 336 | always_clean="yes" |
| 337 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 338 | elif [ "x$1" = "x--never-clean" ]; then |
| 339 | never_clean="yes" |
| 340 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 341 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 342 | run_args="${run_args} --dex2oat-swap" |
| 343 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 344 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 345 | shift |
| 346 | run_args="${run_args} --instruction-set-features $1" |
| 347 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 348 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 349 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 350 | usage="yes" |
| 351 | break |
| 352 | else |
| 353 | break |
| 354 | fi |
| 355 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 356 | |
| 357 | # tmp_dir may be relative, resolve. |
| 358 | # |
| 359 | # Cannot use realpath, as it does not exist on Mac. |
| 360 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 361 | # Cannot use readlink -m, as it does not exist on Mac. |
| 362 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 363 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 364 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 365 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 366 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 367 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 368 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 369 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 370 | fi |
| 371 | if [ "$gc_verify" = "true" ]; then |
| 372 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 373 | fi |
| 374 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | eb19362 | 2015-06-27 15:42:27 -0700 | [diff] [blame] | 375 | run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 376 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 377 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 378 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 379 | if [ "$trace_stream" = "true" ]; then |
| 380 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 381 | # the ability to analyze the file and just write to /dev/null. |
| 382 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 383 | # Enable streaming mode. |
| 384 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 385 | else |
| 386 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 387 | fi |
| 388 | elif [ "$trace_stream" = "true" ]; then |
| 389 | echo "Cannot use --stream without --trace." |
| 390 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 391 | fi |
| 392 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 393 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 394 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 395 | function guess_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 396 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 397 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 398 | if [ "x${suffix64}" = "x64" ]; then |
| 399 | target_arch_name=${grep64bit} |
| 400 | else |
| 401 | target_arch_name=${grep32bit} |
| 402 | fi |
| 403 | } |
| 404 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 405 | if [ "$target_mode" = "no" ]; then |
| 406 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 407 | if [ "$prebuild_mode" = "yes" ]; then |
| 408 | echo "--prebuild with --jvm is unsupported"; |
| 409 | exit 1; |
| 410 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 411 | fi |
| 412 | fi |
| 413 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 414 | if [ "$have_patchoat" = "no" ]; then |
| 415 | run_args="${run_args} --no-patchoat" |
| 416 | fi |
| 417 | |
| 418 | if [ "$have_dex2oat" = "no" ]; then |
| 419 | run_args="${run_args} --no-dex2oat" |
| 420 | fi |
| 421 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 422 | if [ ! "$runtime" = "jvm" ]; then |
| 423 | run_args="${run_args} --lib $lib" |
| 424 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 425 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 426 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 427 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 428 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 429 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 430 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 431 | else |
| 432 | true # defaults to using target BOOTCLASSPATH |
| 433 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 434 | elif [ "$runtime" = "art" ]; then |
| 435 | if [ "$target_mode" = "no" ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 436 | # ANDROID_HOST_OUT is not set in a build environment. |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 437 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 438 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 439 | fi |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 440 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 441 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 442 | else |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 443 | guess_arch_name |
| 444 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 445 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 446 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 447 | if [ "$relocate" = "yes" ]; then |
| 448 | run_args="${run_args} --relocate" |
| 449 | else |
| 450 | run_args="${run_args} --no-relocate" |
| 451 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 452 | elif [ "$runtime" = "jvm" ]; then |
| 453 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 454 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 455 | fi |
| 456 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 457 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 458 | if [ "$runtime" != "art" ]; then |
| 459 | echo "--no-image is only supported on the art runtime" |
| 460 | exit 1 |
| 461 | fi |
| 462 | if [ "$target_mode" = "no" ]; then |
| 463 | framework="${ANDROID_HOST_OUT}/framework" |
| 464 | bpath_suffix="-hostdex" |
| 465 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 466 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 467 | bpath_suffix="" |
| 468 | fi |
| 469 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 470 | # fail since these jar files will be stripped. |
| 471 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
| 472 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 473 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
| 474 | bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar" |
| 475 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 476 | # Pass down the bootclasspath |
| 477 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 478 | run_args="${run_args} --no-image" |
| 479 | fi |
| 480 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 481 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 482 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 483 | usage="yes" |
| 484 | fi |
| 485 | |
| 486 | if [ "$usage" = "no" ]; then |
| 487 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 488 | test_dir=`basename "$oldwd"` |
| 489 | else |
| 490 | test_dir="$1" |
| 491 | fi |
| 492 | |
| 493 | if [ '!' -d "$test_dir" ]; then |
| 494 | td2=`echo ${test_dir}-*` |
| 495 | if [ '!' -d "$td2" ]; then |
| 496 | echo "${test_dir}: no such test directory" 1>&2 |
| 497 | usage="yes" |
| 498 | fi |
| 499 | test_dir="$td2" |
| 500 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 501 | # Shift to get rid of the test name argument. The rest of the arguments |
| 502 | # will get passed to the test run. |
| 503 | shift |
| 504 | fi |
| 505 | |
| 506 | if [ "$usage" = "yes" ]; then |
| 507 | prog=`basename $prog` |
| 508 | ( |
| 509 | echo "usage:" |
| 510 | echo " $prog --help Print this message." |
| 511 | echo " $prog [options] [test-name] Run test normally." |
| 512 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 513 | "(dumps to stdout)." |
| 514 | echo " $prog --update [options] [test-name] Update mode" \ |
| 515 | "(replaces expected.txt)." |
| 516 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 517 | "current directory." |
| 518 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 519 | echo " -O Run non-debug rather than debug build (off by default)." |
| 520 | echo " -Xcompiler-option Pass an option to the compiler." |
| 521 | echo " --runtime-option Pass an option to the runtime." |
| 522 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 523 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 524 | echo " --gdb Run under gdb; incompatible with some tests." |
| 525 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 526 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 527 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 528 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 529 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 530 | echo " --optimizing Enable optimizing compiler (default)." |
| 531 | echo " --quick Use Quick compiler (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 532 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 533 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 534 | echo " Verification is enabled if neither --no-verify" |
| 535 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 536 | echo " --no-optimize Turn off optimization (on by default)." |
| 537 | echo " --no-precise Turn off precise GC (on by default)." |
| 538 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 539 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 540 | echo " other runtime options are ignored." |
| 541 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 542 | echo " --no-patchoat Run as though patchoat was failing." |
| 543 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 544 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 545 | echo " the test." |
| 546 | echo " --relocate Force the use of relocating in the test, making" |
| 547 | echo " the image and oat files be relocated to a random" |
| 548 | echo " address before running. (default)" |
| 549 | echo " --no-relocate Force the use of no relocating in the test" |
| 550 | echo " --host Use the host-mode virtual machine." |
| 551 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 552 | echo " --dalvik Use Dalvik (off by default)." |
| 553 | echo " --jvm Use a host-local RI virtual machine." |
| 554 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 555 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 556 | echo " --64 Run the test in 64-bit mode" |
| 557 | echo " --trace Run with method tracing" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 558 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 559 | echo " --gcstress Run with gc stress testing" |
| 560 | echo " --gcverify Run with gc verification" |
| 561 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 562 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 563 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 564 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 565 | echo " --instruction-set-features [string]" |
| 566 | echo " Set instruction-set-features for compilation." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 567 | ) 1>&2 |
| 568 | exit 1 |
| 569 | fi |
| 570 | |
| 571 | cd "$test_dir" |
| 572 | test_dir=`pwd` |
| 573 | |
| 574 | td_info="${test_dir}/${info}" |
| 575 | td_expected="${test_dir}/${expected}" |
| 576 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 577 | if [ ! -r $td_info ]; then |
| 578 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 579 | exit 1 |
| 580 | fi |
| 581 | |
| 582 | if [ ! -r $td_expected ]; then |
| 583 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 584 | exit 1 |
| 585 | fi |
| 586 | |
| 587 | # copy the test to a temp dir and run it |
| 588 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 589 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 590 | |
| 591 | rm -rf "$tmp_dir" |
| 592 | cp -Rp "$test_dir" "$tmp_dir" |
| 593 | cd "$tmp_dir" |
| 594 | |
| 595 | if [ '!' -r "$build" ]; then |
| 596 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 597 | else |
| 598 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 599 | fi |
| 600 | |
| 601 | if [ '!' -r "$run" ]; then |
| 602 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 603 | else |
| 604 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 605 | fi |
| 606 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 607 | if [ '!' -r "$check_cmd" ]; then |
| 608 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 609 | else |
| 610 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 611 | fi |
| 612 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 613 | chmod 755 "$build" |
| 614 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 615 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 616 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 617 | export TEST_NAME=`basename ${test_dir}` |
| 618 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 619 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 620 | # Checker when compiled with Optimizing on host. |
| 621 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 622 | # Build Checker DEX files without dx's optimizations so the input to dex2oat |
| 623 | # better resembles the Java source. We always build the DEX the same way, even |
| 624 | # if Checker is not invoked and the test only runs the program. |
| 625 | build_args="${build_args} --dx-option --no-optimize" |
| 626 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 627 | # Jack does not necessarily generate the same DEX output than dx. Because these tests depend |
| 628 | # on a particular DEX output, keep building them with dx for now (b/19467889). |
| 629 | USE_JACK="false" |
| 630 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 631 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$debuggable" = "no" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 632 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 633 | # patchoat are available. Disable Checker otherwise (b/22552692). |
| 634 | if [ "$prebuild_mode" = "yes" ] || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
| 635 | run_checker="yes" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 636 | if [ "$target_mode" = "no" ]; then |
| 637 | cfg_output_dir="$tmp_dir" |
| 638 | checker_arch_option= |
| 639 | else |
| 640 | cfg_output_dir="$DEX_LOCATION" |
| 641 | checker_arch_option="--arch=${target_arch_name^^}" |
| 642 | fi |
| 643 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 644 | -Xcompiler-option -j1" |
| 645 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 646 | fi |
| 647 | fi |
| 648 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 649 | if [ "$runtime" != "jvm" ]; then |
| 650 | run_args="${run_args} --testlib ${testlib}" |
| 651 | fi |
| 652 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 653 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 654 | build_file_size_limit=2048 |
| 655 | run_file_size_limit=2048 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 656 | if echo "$test_dir" | grep 089; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 657 | build_file_size_limit=5120 |
| 658 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 659 | elif echo "$test_dir" | grep 083; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 660 | build_file_size_limit=5120 |
| 661 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 662 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 663 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 664 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 665 | # run checker on it. This file can be big. |
| 666 | build_file_size_limit=16384 |
| 667 | run_file_size_limit=16384 |
| 668 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 669 | if [ ${USE_JACK} = "false" ]; then |
| 670 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 671 | if ! ulimit -S "$build_file_size_limit"; then |
| 672 | echo "ulimit file size setting failed" |
| 673 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 674 | fi |
| 675 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 676 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 677 | good_build="yes" |
| 678 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 679 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 680 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 681 | build_exit="$?" |
| 682 | echo "build exit status: $build_exit" 1>&2 |
| 683 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 684 | if ! ulimit -S "$run_file_size_limit"; then |
| 685 | echo "ulimit file size setting failed" |
| 686 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 687 | echo "${test_dir}: running..." 1>&2 |
| 688 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 689 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 690 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 691 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 692 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 693 | if [ "$target_mode" = "yes" ]; then |
| 694 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 695 | fi |
| 696 | "$checker" $checker_arch_option "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 697 | checker_exit="$?" |
| 698 | if [ "$checker_exit" = "0" ]; then |
| 699 | good="yes" |
| 700 | fi |
| 701 | echo "checker exit status: $checker_exit" 1>&2 |
| 702 | else |
| 703 | good="yes" |
| 704 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 705 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 706 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 707 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 708 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 709 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 710 | build_exit="$?" |
| 711 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 712 | if ! ulimit -S "$run_file_size_limit"; then |
| 713 | echo "ulimit file size setting failed" |
| 714 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 715 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 716 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 717 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 718 | if [ "$target_mode" = "yes" ]; then |
| 719 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 720 | fi |
| 721 | "$checker" -q $checker_arch_option "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 722 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 723 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 724 | good="yes" |
| 725 | else |
| 726 | cat "$build_output" 1>&2 |
| 727 | echo "build exit status: $build_exit" 1>&2 |
| 728 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 729 | elif [ "$build_only" = "yes" ]; then |
| 730 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 731 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 732 | build_exit="$?" |
| 733 | if [ "$build_exit" '!=' '0' ]; then |
| 734 | cp "$build_output" "$output" |
| 735 | echo "build exit status: $build_exit" >>"$output" |
| 736 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 737 | if [ "$?" '!=' "0" ]; then |
| 738 | good="no" |
| 739 | echo "BUILD FAILED For ${TEST_NAME}" |
| 740 | fi |
| 741 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 742 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 743 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 744 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 745 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 746 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 747 | build_exit="$?" |
| 748 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 749 | if ! ulimit -S "$run_file_size_limit"; then |
| 750 | echo "ulimit file size setting failed" |
| 751 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 752 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 753 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 754 | run_exit="$?" |
| 755 | if [ "$run_exit" != "0" ]; then |
| 756 | echo "run exit status: $run_exit" 1>&2 |
| 757 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 758 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 759 | if [ "$target_mode" = "yes" ]; then |
| 760 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 761 | fi |
| 762 | "$checker" -q $checker_arch_option "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 763 | checker_exit="$?" |
| 764 | if [ "$checker_exit" != "0" ]; then |
| 765 | echo "checker exit status: $checker_exit" 1>&2 |
| 766 | good_run="no" |
| 767 | else |
| 768 | good_run="yes" |
| 769 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 770 | else |
| 771 | good_run="yes" |
| 772 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 773 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 774 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 775 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 776 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 777 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 778 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 779 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 780 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 781 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 782 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 783 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 784 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 785 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 786 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 787 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 788 | # output == expected |
| 789 | good="yes" |
| 790 | echo "${test_dir}: succeeded!" 1>&2 |
| 791 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 792 | fi |
| 793 | fi |
| 794 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 795 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 796 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 797 | echo "${test_dir}: FAILED!" |
| 798 | echo ' ' |
| 799 | echo '#################### info' |
| 800 | cat "${td_info}" | sed 's/^/# /g' |
| 801 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 802 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 803 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 804 | if [ "$strace" = "yes" ]; then |
| 805 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 806 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 807 | echo '####################' |
| 808 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 809 | echo ' ' |
| 810 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 811 | |
| 812 | ) 1>&2 |
| 813 | |
| 814 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 815 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 816 | cd "$oldwd" |
| 817 | rm -rf "$tmp_dir" |
| 818 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 819 | adb shell rm -rf $DEX_LOCATION |
| 820 | fi |
| 821 | if [ "$good" = "yes" ]; then |
| 822 | exit 0 |
| 823 | fi |
| 824 | fi |
| 825 | |
| 826 | |
| 827 | ( |
| 828 | if [ "$always_clean" = "yes" ]; then |
| 829 | echo "${TEST_NAME} files deleted from host " |
| 830 | if [ "$target_mode" == "yes" ]; then |
| 831 | echo "and from target" |
| 832 | fi |
| 833 | else |
| 834 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 835 | if [ "$target_mode" == "yes" ]; then |
| 836 | echo "and in ${DEX_LOCATION} on target" |
| 837 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 838 | fi |
| 839 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 840 | ) 1>&2 |
| 841 | |
| 842 | exit 1 |